/*$Id: u_nodemap.h,v 25.25 2005/06/02 08:02:27 al Exp $ -*- C++ -*-
 * Copyright (C) 2002 Albert Davis
 * Author: Albert Davis <aldavis@ieee.org>
 *
 * This file is part of "Gnucap", the Gnu Circuit Analysis Package
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *------------------------------------------------------------------
 * node name to number mapping -- for named nodes
 */
#ifndef U_NODEMAP_H
#define U_NODEMAP_H
#include "md.h"
/*--------------------------------------------------------------------------*/
class NODE;
/*--------------------------------------------------------------------------*/
class NODE_MAP {
private:
  int _count;
  std::map<const std::string, NODE*> _node_map;
  std::vector<NODE*> _nodes;
private:
  explicit  NODE_MAP(const NODE_MAP&);
public:
  explicit  NODE_MAP();
  NODE*	    operator[](int)const;
  NODE*     operator[](const std::string&);
  NODE*     new_node(const std::string&);

  typedef std::vector<NODE*>::iterator iterator;
  typedef std::vector<NODE*>::const_iterator const_iterator;

  // return an iterator
  iterator begin()			{return _nodes.begin();}
  iterator end()			{return _nodes.end();}

  // return a const_iterator
  const_iterator begin()const		{return _nodes.begin();}
  const_iterator end()const		{return _nodes.end();}
};
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
#endif
